/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-07-30 15:41
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(int i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef long double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

ll N, M, H;

pll getNextResult(){
    ll time;
    vector<ll> times;
    R(j, M){
        cin >> time;
        times.push_back(time);
    }
    sort(times.begin(), times.end());

    ll solvetime = 0, solves = 0, curtime = 0;
    for(ll t: times)
        if(curtime + t <= H){
            curtime += t;
            solvetime += curtime;
            solves++;
        }
    return {-solves, solvetime};
}
    
void solve(){
    // Code goes here ...
    cin >> N >> M >> H;
    
    pll RudolfResult = getNextResult();
    vector<pll> results{RudolfResult};
    R(i, N - 1)
        results.push_back(getNextResult());
    
    sort(results.begin(), results.end());

    cout << distance(results.begin(), find(results.begin(), results.end(), RudolfResult)) + 1 << endl;
}

int main(){
    cout << fixed << setprecision(8);
    int T;
    cin >> T;
    while(T--)
        solve();
}
        
